/*
 * 11/11/2001 - 17:58:01
 *
 * QRALocator.java - Applet permettant la transformation de coordonnes.
 * Copyright (C) 2001 C. Mercier
 * c.avmdti@free.fr
 * www.avmdti.org
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
*
* Titre : QRA LOCATOR
* Version : 1.0
* Copyright : Copyright (c) C. Mercier
* Auteur : C. Mercier
* Socit : www.avmdti.org
* Description : outil de calcul pour le QRA locator sous forme d'applet ou d'application
*/
package org.avmdti.qralocator.applet;

import org.avmdti.qralocator.*;
import org.avmdti.qralocator.ihm.*;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class QraLocator extends Applet {
        boolean isStandalone = false;
        GridLayout gridLayout1 = new GridLayout();
        PanelLatLong panel_latlong = new PanelLatLong();
        PanelLocator panel_locator = new PanelLocator();
        Panel panelcontrol = new Panel();
        Button buttontoLocator = new Button();
        Button buttonfromLocator = new Button();

        //Obtenir une valeur de paramtre
        public String getParameter(String key, String def) {
                return isStandalone ? System.getProperty(key, def) :
                        (getParameter(key) != null ?
                        getParameter(key) : def);
        }

        //Construire l'applet
        public QraLocator() {
        }

        //Initialiser l'applet
        public void init() {
                try {
                        jbInit();
                } catch (Exception e) {
                        e.printStackTrace();
                }
        }

        //Initialiser le composant
        private void jbInit() throws Exception {
                this.setLayout(gridLayout1);
                gridLayout1.setRows(3);
                buttontoLocator.setBackground(
                        SystemColor.activeCaptionText);
                buttontoLocator.setFont(
                        new java.awt.Font("Dialog", 1, 12));
                buttontoLocator.setLabel("lat-long to Locator");
                buttontoLocator.addActionListener(
                        new java.awt.event.ActionListener() {

                                                          public void actionPerformed(
                                                                  ActionEvent e) {
                                                                  buttontoLocator_actionPerformed(e);
                                                          }
                                                  }
                                                 );
                buttonfromLocator.setBackground(
                        SystemColor.activeCaptionText);
                buttonfromLocator.setFont(
                        new java.awt.Font("Dialog", 1, 12));
                buttonfromLocator.setLabel("Locator to lat-long");
                buttonfromLocator.addActionListener(
                        new java.awt.event.ActionListener() {

                                                            public void actionPerformed(
                                                                    ActionEvent e) {
                                                                    buttonfromLocator_actionPerformed(e);
                                                            }
                                                    }
                                                   );
                this.setBackground(Color.lightGray);
                this.add(panel_latlong, null);
                this.add(panel_locator, null);
                this.add(panelcontrol, null);
                panelcontrol.add(buttonfromLocator, null);
                panelcontrol.add(buttontoLocator, null);
        }

        //Dmarrer l'applet
        public void start() {
        }

        //Arrter l'applet
        public void stop() {
        }

        //Dtruire l'applet
        public void destroy() {
        }

        //Obtenir les informations d'applet
        public String getAppletInfo() {
                return "Information applet";
        }

        //Obtenir les informations de paramtre
        public String[][] getParameterInfo() {
                return null;
        }

        //Mthode principale
        public static void main(String[] args) {
                QraLocator applet = new QraLocator();
                applet.isStandalone = true;
                Frame frame;
                frame = new Frame() {

                                protected void processWindowEvent(
                                        WindowEvent e) {
                                        super.processWindowEvent(e);
                                if (e.getID() ==
                                        WindowEvent.WINDOW_CLOSING) {
                                                System.exit(0);
                                        }
                                }

                        public synchronized void setTitle(String title) {
                                        super.setTitle(title);
                                        enableEvents(
                                                AWTEvent.WINDOW_EVENT_MASK);
                                }
                        };
                frame.setTitle("QRA Locator to/from geographic coordinate");
                frame.add(applet, BorderLayout.CENTER);
                applet.init();
                applet.start();
                frame.setSize(400, 320);
                Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
                frame.setLocation((d.width - frame.getSize().width) /
                        2, (d.height - frame.getSize().height) / 2);
                frame.setVisible(true);
        }

        void buttonfromLocator_actionPerformed(ActionEvent e) {
                org.avmdti.qralocator.QraLocator QL =
                        new org.avmdti.qralocator.QraLocator();
                String S = panel_locator.getLocator();
                coord C = QL.FromLocator(S);
                panel_latlong.setCoordonnee(C);

        }

        void buttontoLocator_actionPerformed(ActionEvent e) {
                org.avmdti.qralocator.QraLocator QL =
                        new org.avmdti.qralocator.QraLocator();
                coord C = panel_latlong.getCoordonnee();
                String S = QL.ToLocator(C._longitude, C._latitude);
                panel_locator.setLocator(S);

        }
}

